package com.ethornium.encoding;

import com.ethornium.encoding.enums.EOperator;
import com.ethornium.encoding.enums.ESort;

import java.util.ArrayList;
import java.util.Arrays;

public class EExpr extends AtomExpr {
    ESort opSort = null;
    EOperator op = EOperator.prim;
    ArrayList<EExpr> arg = null;
    EFunc func = null;

    public EExpr(int value){
        super(value);
    }

    public EExpr (boolean value) { super(value); }

    public EOperator getExpressionType(){
        return this.op;
    }

    public EFunc getFunction(){
        return this.func;
    }

    public ArrayList<EExpr> getArg() {
        return arg;
    }

    public EExpr(String value){
        super(value);
    }

    public EExpr(ESort sort, int value){
        super(sort, value);
    }

    public EExpr(EOperator op, ESort opSort, EExpr... arg){
        super(0);
        this.opSort = opSort;
        this.op = op;
        this.arg = new ArrayList<>(Arrays.asList(arg));
    }

    public EExpr(EFunc func, EExpr... arg){
        super(0);
        this.func = func;
        this.op = EOperator.pred;
        this.arg = new ArrayList<>(Arrays.asList(arg));
    }
}