package com.ethornium.encoding;

import java.util.ArrayList;

public class InternalRepresentation {
    private final int opcode;
    private final String arg;
    private final int pc;
    private final ArrayList<String> computedArguments;
    private boolean visited;

    public InternalRepresentation(int opc, int programCounter, String argument) {
        this.opcode = opc;
        this.arg = argument;
        this.pc = programCounter;
        this.computedArguments = new ArrayList<>();
        this.visited = false;
    }

    public void setVisited(){
        this.visited = true;
    }

    public boolean isVisited(){
        return this.visited;
    }

    public int getOpCode() {
        return opcode;
    }

    public String getArg() {
        return arg;
    }

    public void putComputedArgument(String computedArgument){
        this.computedArguments.add(computedArgument);
    }

    public ArrayList<String> getComputedArguments(){
        return computedArguments;
    }

    public int getPc() {
        return pc;
    }

    @Override
    public int hashCode() {
        return opcode * pc * arg.hashCode();
    }

    @Override
    public boolean equals(Object o) {
        if (!(o instanceof InternalRepresentation)) return false;
        InternalRepresentation intrepo = (InternalRepresentation) o;
        return this.opcode == intrepo.getOpCode() && this.pc == intrepo.getPc() &&
                this.arg.equals(intrepo.getArg());
    }
}