package com.ethornium.encoding;

import com.ethornium.encoding.enums.ESort;

import java.util.ArrayList;
import java.util.Arrays;

public class Pred {
    private final ArrayList<EFunc> mFuncs;
    public Pred(final ArrayList<EFunc> mFuncs){
        this.mFuncs = mFuncs;
    }

    /*public EExpr checkPremsEXPPred(String c, Integer pc, EExpr g, EExpr x, EExpr y, EExpr cost) {
            String funcName = "checkPremsEXP_" + c + '_' + pc.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, g, x, y, cost);
    }*/

    /*public EExpr expCost(EExpr v, EExpr rez) {
        String funcName = "exprCost";
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, v, rez);
    }*/


    /*public EExpr powerF(EExpr arg, EExpr exp, EExpr rez) {
        String funcName = "powerF";
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, arg, exp, rez);
    }*/

    public EExpr checkPremsEXPPred(String c, Integer pc, EExpr x, EExpr y
                                         , EExpr size, EExpr stack, EExpr stackT, EExpr stackS, EExpr taint, Integer cd
    ) {
        String funcName = "checkPremsEXP_" + c + "_" + pc.toString() + "_" + cd.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort,
                ESort.ArraySortInt, ESort.ArraySortT, ESort.ArraySortS, ESort.Taint};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, x, y, size, stack, stackT, stackS, taint);
    }

    /*public EExpr gasPred(String c, Integer pc, EExpr g
    ) {
        String funcName = "gas_" + c + "_" + pc.toString();
        ESort[] domains = new ESort[]{ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, g);
    }*/

    /*public EExpr checkPremsEXPPredSimple(String c, Integer pc, EExpr g, EExpr x, EExpr y, EExpr cost,
                                         EExpr gc,  EExpr gas, EExpr size, EExpr stack, EExpr aw) {
        String funcName = "checkPremsEXPSIMPLE_" + c + '_' + pc.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort,
                ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.ArraySort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, g, x, y, cost, gc, gas, size, stack, aw);
    }

    public EExpr checkPremsEXPPredComplex(String c, Integer pc, EExpr g, EExpr x, EExpr y, EExpr cost,
                                          EExpr gc,  EExpr gas, EExpr size, EExpr stack, EExpr aw) {
        String funcName = "checkPremsEXPCOMPLEX_" + c + '_' + pc.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort,
                ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.ArraySort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, g, x, y, cost, gc, gas, size, stack, aw);
    }*/

    /*public EExpr checkPremsSHA3Pred(String c, Integer pc, EExpr newaw) {
            String funcName = "checkPremsSHA3_" + c + '_' + pc.toString();
            ESort[] domains = new ESort[]{ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, newaw);
    }*/

    public EExpr codePred(String c, EExpr pos, EExpr com) {
            String funcName = "codePred_" + c;
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, pos, com);
    }

    public EExpr checkPremsCODECOPYPred(String c, Integer pc, EExpr posmem, EExpr poscom,
                                         EExpr s, EExpr taint, Integer cd) {
        String funcName = "checkPremsCODECOPY_" + c + "_" + pc.toString() + "_" + cd.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.Taint};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, posmem, poscom, s, taint);
    }

    /*public EExpr checkPremsCALLDATALOADPred(String c, Integer pc, EExpr pos, EExpr inputsize) {
            String funcName = "checkPremsCALLDATALOAD_" + c + "_" + pc.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, pos, inputsize);
    }*/

    /*public EExpr checkPremsJUMPPred(String c, Integer pc, EExpr i) {
            String funcName = "checkPremsJUMP_" + c + '_' + pc.toString();
            ESort[] domains = new ESort[]{ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, i);
    }*/

    public EExpr checkPremsJUMPIPred(String c, Integer pc, EExpr i, EExpr bcond, EExpr bcondT, EExpr bcondS, EExpr taint, Integer cd) {
            String funcName = "checkPremsJUMPI_" + c + "_" + pc.toString() + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.Taint, ESort.Symbolic, ESort.Taint};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, i, bcond, bcondT, bcondS, taint);
    }

    public EExpr checkPremsMLOADPred(String c, Integer pc, EExpr ma, EExpr taint, Integer cd) {
            String funcName = "checkPremsMLOAD_" + c + "_" + pc.toString() + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.Taint};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, ma, taint);
    }

    /*public EExpr checkPremsMLOADPredSimple(String c, Integer pc, EExpr g, EExpr cost, EExpr ma, EExpr awnew,
                                           EExpr gc,  EExpr gas, EExpr size, EExpr stack, EExpr aw) {
            String funcName = "checkPremsMLOADSIMPLE_" + c + '_' + pc.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort,
                    ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.ArraySort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, g, cost, ma, awnew, gc, gas, size, stack, aw);
    }

    public EExpr checkPremsMLOADPredComplex(String c, Integer pc, EExpr g, EExpr cost, EExpr ma, EExpr awnew,
                                            EExpr gc,  EExpr gas, EExpr size, EExpr stack, EExpr aw) {
        String funcName = "checkPremsMLOADCOMPLEX_" + c + '_' + pc.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort,
                ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.ArraySort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, g, cost, ma, awnew, gc, gas, size, stack, aw);
    }*/

    public EExpr checkPremsMSTOREPred(String c, Integer pc, EExpr ma, EExpr v, EExpr yt, EExpr ys, EExpr taint, Integer cd) {
            String funcName = "checkPremsMSTORE_" + c + "_" + pc.toString() + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.Taint, ESort.Symbolic, ESort.Taint};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, ma, v, yt, ys, taint);
    }

    /*public EExpr checkPremsMSTOREPredSimple(String c, Integer pc, EExpr g, EExpr cost, EExpr ma, EExpr v, EExpr awnew,
                                            EExpr gc,  EExpr gas, EExpr size, EExpr stack, EExpr aw) {
        String funcName = "checkPremsMSTORESIMPLE_" + c + '_' + pc.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort,
                ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.ArraySort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, g, cost, ma, v, awnew, gc, gas, size, stack, aw);
    }

    public EExpr checkPremsMSTOREPredComplex(String c, Integer pc, EExpr g, EExpr cost, EExpr ma, EExpr v, EExpr awnew,
                                             EExpr gc,  EExpr gas, EExpr size, EExpr stack, EExpr aw) {
        String funcName = "checkPremsMSTORECOMPLEX_" + c + '_' + pc.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort,
                ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.ArraySort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, g, cost, ma, v, awnew, gc, gas, size, stack, aw);
    }*/

    public EExpr checkPremsSSTOREPred(String c, Integer pc, EExpr ma, EExpr y, EExpr yt, EExpr ys, EExpr taint, Integer cd) {
            String funcName = "checkPremsSSTORE_" + c + "_" + pc.toString() + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.Taint, ESort.Symbolic, ESort.Taint};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, ma, y, yt, ys, taint);
    }

    public EExpr mStatePredMem(String c, Integer pc, EExpr size, EExpr stack, EExpr stackT, EExpr stackS, EExpr taint, Integer cd, EExpr... mem) {
            String funcName = "mStateMem_" + c + "_" + pc.toString() + "_" + cd.toString();
            ESort[] domains = new ESort[2 + mem.length];
            domains[0] = ESort.IntSort; domains[1] = ESort.ArraySortInt; domains[2] = ESort.ArraySortT; domains[3] = ESort.ArraySortS; domains[4] = ESort.Taint;
            Arrays.fill(domains, 5, 5 + mem.length, ESort.IntSort);
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            ArrayList<EExpr> argList = new ArrayList<>();
            argList.add(size); argList.add(stack); argList.add(stackT); argList.add(stackS); argList.add(taint);
            for (EExpr memel: mem){
                argList.add(memel);
            }
            EExpr[] arg = argList.toArray(new EExpr[0]);
            return new EExpr(f, arg);
    }

    public EExpr mStatePred(String c, Integer pc, EExpr size, EExpr stack, EExpr stackT, EExpr stackS, EExpr taint, Integer cd) {
            String funcName = "mState_" + c + "_" + pc.toString() + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.ArraySortInt, ESort.ArraySortT, ESort.ArraySortS, ESort.Taint};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, size, stack, stackT, stackS, taint);
    }

    public EExpr memPred(String c, Integer pc, EExpr pos, EExpr va, EExpr taint, EExpr symbol, Integer cd) {
        String funcName = "memPred_" + c + "_" + pc.toString() + "_" + cd.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.Taint, ESort.Symbolic};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, pos, va, taint, symbol);
    }

    /*public EExpr exenvPred(String c, EExpr a, EExpr i, Integer cd, EExpr v, EExpr inputsize) {
            String funcName = "exenvPred_" + "_" + c + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, a, i, v, inputsize);
    }*/

    public EExpr gStatePred(String c, Integer pc, EExpr n, EExpr b, Integer cd) {
            String funcName = "gState_" + c + "_" + pc.toString() + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, n, b);
    }

    public EExpr storPred(String c, Integer pc, EExpr posStor, EExpr vaStor, EExpr taint, EExpr symbol, Integer cd) {
            String funcName = "storPred_" + c + "_" + pc.toString() + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.Taint, ESort.Symbolic};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, posStor, vaStor, taint, symbol);
    }

    /*public EExpr inputDataPred(String c, EExpr pos, EExpr v, Integer cd) {
            String funcName = "inputData_" + c + "_" + cd.toString();
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, pos, v);
    }*/

    /*public EExpr ExcPred1(String c) {
        //todo
            String funcName = "ECXC_" + c;
            ESort[] domains = new ESort[]{ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f);
    }

    public EExpr returnPred(String c, EExpr returndatasize, Integer cd) {
            String funcName = "returnPred_" + c;
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntConst};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, returndatasize, cd);
    }

    public EExpr checkPremsCALLPred(String c, Integer pc, EExpr a, EExpr to, EExpr va, EExpr io, EExpr is, EExpr id) {
        String funcName = "checkPremsCALL_" + c + "_" + pc.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f,a, to, va, io, is, id);
    } */

    public EExpr checkPremsCALLunknownPred(String c, Integer pc, EExpr to, EExpr va, EExpr oo, EExpr os, EExpr taint, Integer cd) {
        String funcName = "checkPremsCALL_" + c + "_" + pc.toString() + "_" + cd.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.Taint};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, to, va, oo, os, taint);
    }

    /* public EExpr checkPremsCALLretPred(String c, Integer pc, EExpr to, EExpr oo, EExpr k, Integer cd) {
        String funcName = "checkPremsCALLret_" + c + "_" + pc.toString();
        ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort, ESort.IntSort};
        EFunc f = new EFunc(funcName, domains);
        mFuncs.add(f);
        return new EExpr(f, to, oo, k, cd);
    }

    public EExpr resPred(String c, EExpr pos, EExpr v) {
            String funcName = "res_" + c;
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, pos, v);
    }

    public EExpr resgStatePred(String c, EExpr a, EExpr n, EExpr b) {
            String funcName = "resgState_" + c;
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, a, n, b);
    }

    public EExpr resStorPred(String c, EExpr a, EExpr pos, EExpr v) {
            String funcName = "resStore_" + c;
            ESort[] domains = new ESort[]{ESort.IntSort, ESort.IntSort, ESort.IntSort};
            EFunc f = new EFunc(funcName, domains);
            mFuncs.add(f);
            return new EExpr(f, a, pos, v);
    }*/
}
