package com.ethornium.z3;


import com.ethornium.encoding.*;
import com.ethornium.encoding.enums.*;
import com.microsoft.z3.*;
import com.microsoft.z3.Symbol;
import com.sun.org.apache.xpath.internal.operations.Bool;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import javax.print.attribute.IntegerSyntax;
import java.util.*;
import java.util.concurrent.*;

public class Query {
    private static final Logger LOGGER = LogManager.getLogger(Query.class);
    private final Pred pred;
    //private final ArrayList<EFunc> mFuncs;
    private final ArrayList<EExpr> mRules;
    private final ArrayList<EExpr> mQueriesRe;
    private final ArrayList<EExpr> mQueriesDe;
    private final Map<Integer, InternalRepresentation> internalByteCode;
    private final Map<Contract, Integer> contracts;
    private final VarMap varMap;
    private boolean memBound;
    private int timeBound;

    public Query(final Pred pred, final ArrayList<EExpr> mRules, final ArrayList<EExpr> mQueriesRe, final ArrayList<EExpr> mQueriesDe,
                 Map<Integer, InternalRepresentation> internalByteCode, Map<Contract, Integer> contracts,
                 final VarMap varMap, boolean memBound, int timeBound) {
        this.pred = pred;
        this.mRules = mRules;
        this.mQueriesRe = mQueriesRe;
        this.mQueriesDe = mQueriesDe;
        this.internalByteCode = internalByteCode;
        this.contracts = contracts;
        this.varMap = varMap;
        this.memBound = memBound;
        this.timeBound = timeBound;
    }

    private void initialise() {
        //Global.setParameter("fixedpoint.engine", "pdr");
        Global.setParameter("fixedpoint.engine", "spacer");

//        Global.setParameter("fixedpoint.spacer.eager_reach_check", "false");
//        Global.setParameter("fixedpoint.spacer.use_lemma_as_cti", "true");
//        Global.setParameter("fixedpoint.spacer.reset_obligation_queue", "false");
//        Global.setParameter("fixedpoint.spacer.use_array_eq_generalizer", "false");
//        Global.setParameter("fixedpoint.spacer.use_derivations", "false");
//        Global.setParameter("fixedpoint.spacer.skip_propagate", "true");
//        Global.setParameter("fixedpoint.spacer.max_level", "2");
//        Global.setParameter("fixedpoint.spacer.elim_aux", "false");
////        Global.setParameter("fixedpoint.spacer.reach_as_init", "false");
//        Global.setParameter("fixedpoint.spacer.blast_term_ite", "false");
//        Global.setParameter("fixedpoint.spacer.nondet_tie_break", "true");
//        Global.setParameter("fixedpoint.spacer.reach_dnf", "false");
//        Global.setParameter("fixedpoint.spacer.split_farkas_literals", "true");
//        Global.setParameter("fixedpoint.spacer.native_mbp", "true");
//        Global.setParameter("fixedpoint.spacer.eq_prop", "false");
//        Global.setParameter("fixedpoint.spacer.weak_abs", "true");
//        Global.setParameter("fixedpoint.spacer.restarts", "true");
////
//        Global.setParameter("fixedpoint.spacer.ground_cti", "false");
//        Global.setParameter("fixedpoint.spacer.mbqi", "false");
////        Global.setParameter("fixedpoint.spacer.keep_proxy", "false");
//        Global.setParameter("fixedpoint.spacer.instantiate", "false");
//        Global.setParameter("fixedpoint.spacer.qlemmas", "false");
////        Global.setParameter("fixedpoint.spacer.new_unsat_core", "false");
//        Global.setParameter("fixedpoint.spacer.minimize_unsat_core", "true");
//        Global.setParameter("fixedpoint.spacer.farkas_optimized", "false");
////        Global.setParameter("fixedpoint.spacer.farkas_a_const", "false");
////
////        Global.setParameter("fixedpoint.spacer.lemma_sanity_check", "true");
////        Global.setParameter("fixedpoint.spacer.reuse_pobs", "false");
////        Global.setParameter("fixedpoint.spacer.simplify_pob", "true");



        //Global.setParameter("pdr.flexible_trace","true");
        //Global.setParameter("pp.bv-literals", "false");

        //Global.setParameter("fixedpoint.print_answer", "true");
        //Global.setParameter("fixedpoint.generate_proof_trace", "true");
        //Global.setParameter("pp.pretty_proof", "true");
        //Global.setParameter("print-certificate","true");

        //Global.setParameter("fixedpoint.xform.quantify_arrays", "true");
    }

    public void ExecuteQueriesCheck(final int gasLimit, final String maxEvmValue, final int GUARD) throws ExecutionException, InterruptedException {
//        int counter = 0;
//        for (Map.Entry<Contract, Integer> contract : contracts.entrySet()) {
//
//
//            String contractID = Integer.toString(contract.getValue());
//
//            /*EExpr checkPremsMSTORE = pred.checkPremsMSTOREPred(contractID, pc, varMap.getIntExpr(EVarInt.g), varMap.getIntExpr(EVarInt.cost), varMap.getIntExpr(EVarInt.ma),
//                    varMap.getIntExpr(EVarInt.va), varMap.getIntExpr(EVarInt.awnew));*/
//
//            /*for (int x = 1; x < 32; x++) {*/
//                /*EExpr maMod32eqx = EEngine.eq(EEngine.mod(varMap.getIntExpr(EVarInt.ma), EEngine.num(32)), EEngine.num(x));
//                EExpr memLeftWord = pred.memPred(contractID, pc, varMap.getIntExpr(EVarInt.g),
//                        EEngine.sub(varMap.getIntExpr(EVarInt.ma), EEngine.num(x)), varMap.getIntExpr(EVarInt.val0));
//                EExpr vNewLeftWord = EEngine.eq(
//                        varMap.getIntExpr(EVarInt.vnew),
//                        EEngine.concat(
//                                EEngine.extract(varMap.getIntExpr(EVarInt.val0), 0, x - 1),
//                                EEngine.extract(varMap.getIntExpr(EVarInt.va), 0, 31 - x),
//                                32 - x)
//                );
//
//                EExpr h = EEngine.and(
//                        checkPremsMSTORE,
//                        maMod32eqx,
//                        memLeftWord,
//                        vNewLeftWord
//                );*/
//
//            int pc = 14;
//
//            EExpr mState = pred.mStatePred(contractID, pc, varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//            EExpr maEqSa = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.ma),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1)))
//            );
//
//            // CALLDATALOAD
//
//            EExpr posEqSa = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.pos),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack),
//                            EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))
//                    ));
//
//
//            EExpr exenv = pred.exenvPred(contractID,
//                    varMap.getIntExpr(EVarInt.a),
//                    varMap.getIntExpr(EVarInt.i),
//                    varMap.getIntExpr(EVarInt.cd),
//                    varMap.getIntExpr(EVarInt.va),
//                    varMap.getIntExpr(EVarInt.inputsize));
//
//            EExpr inputData = pred.inputDataPred(contractID,
//                    varMap.getIntExpr(EVarInt.pos),
//                    EEngine.num(2050554347));
//
//            EExpr posLtInputsize = EEngine.lt(
//                    varMap.getIntExpr(EVarInt.pos),
//                    varMap.getIntExpr(EVarInt.inputsize)
//            );
//
//            EExpr va = EEngine.checkValid(
//                    varMap.getIntExpr(EVarInt.size),
//                    EEngine.sub(varMap.getIntExpr(EVarInt.size), 1));
//
//            EExpr hDATA = EEngine.and(
//                    mState,
//                    posEqSa,
//                    EEngine.eq(EEngine.mod(varMap.getIntExpr(EVarInt.pos), EEngine.num(32)), EEngine.num(0)),
//                    exenv,
//                    posLtInputsize,
//                    inputData,
//                    va
//            );
//
//            EExpr awNewEqMax = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.awnew),
//                    EEngine.max(
//                            varMap.getIntExpr(EVarInt.aw),
//                            EEngine.divCeiling(
//                                    EEngine.add(varMap.getIntExpr(EVarInt.ma), EEngine.num(32)),
//                                    EEngine.num(32))
//                    )
//            );
//
//            EExpr costEqCmem = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.cost),
//                    EEngine.add(EEngine.cMem(varMap.getIntExpr(EVarInt.aw), varMap.getIntExpr(EVarInt.awnew)),
//                            EEngine.num(3))
//            );
//
//            EExpr valid = EEngine.checkValid(
//                    varMap.getIntExpr(EVarInt.size),
//                    EEngine.sub(varMap.getIntExpr(EVarInt.size), 1));
//
//
//            EExpr hq = EEngine.and(
//                    mState,
//                    maEqSa,
//                    awNewEqMax,
//                    costEqCmem,
//                    valid
//            );
//            /*EExpr checkPrems = pred.checkPremsMLOADPred(contractID, pc, varMap.getIntExpr(EVarInt.g), varMap.getIntExpr(EVarInt.cost),
//                    //varMap.getIntExpr(EVarInt.ma),
//                    varMap.getIntExpr(EVarInt.ma),
//                    varMap.getIntExpr(EVarInt.awnew));*/
//
//            //EExpr bq = checkPrems;
//
//            EExpr r = pred.storPred(contractID, 60,
//                    varMap.getIntExpr(EVarInt.a),
//                    EEngine.num(1),
//                    varMap.getIntExpr(EVarInt.v));
//
//            EExpr r1 =
//                    pred.exenvPred(contractID,
//                            varMap.getIntExpr(EVarInt.a),
//                            varMap.getIntExpr(EVarInt.i),
//                            varMap.getIntExpr(EVarInt.cd),
//                            varMap.getIntExpr(EVarInt.va),
//                            varMap.getIntExpr(EVarInt.size));
//
//
//            //SLOAD
//
//            EExpr premState = pred.mStatePred(contractID, 60,
//                    varMap.getIntExpr(EVarInt.size),
//                    varMap.getArrExpr(EVarArr.stack),
//                    varMap.getIntExpr(EVarInt.aw));
//
//            valid = EEngine.checkValid(
//                    varMap.getIntExpr(EVarInt.size),
//                    EEngine.sub(varMap.getIntExpr(EVarInt.size), 1));
//
//            EExpr exenvPredicate = pred.exenvPred(
//                    contractID,
//                    varMap.getIntExpr(EVarInt.a),
//                    varMap.getIntExpr(EVarInt.i),
//                    varMap.getIntExpr(EVarInt.cd),
//                    varMap.getIntExpr(EVarInt.va),
//                    varMap.getIntExpr(EVarInt.inputsize));
//
//            EExpr preStorLOAD = pred.storPred(contractID, 60,
//                    varMap.getIntExpr(EVarInt.a),
//                    varMap.getIntExpr(EVarInt.ma),
//                    varMap.getIntExpr(EVarInt.va));
//
//            EExpr ma = EEngine.eq(EEngine.num(1),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), 1)));
//
//            EExpr hlll = EEngine.and(
//                    premState,
//                    //valid,
//                    //exenvPredicate
//                    ma
//                    //preStorLOAD
//            );
//            //////
//
//            //mRules.add(EEngine.implies(hq, bq));
//
//            // Case 1
//
//            EExpr mState1 = pred.mStatePred(contractID, pc, varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//            EExpr maEqSa1 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.ma),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1)))
//            );
//
//            EExpr awNewEqMax1 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.awnew),
//                    EEngine.max(
//                            varMap.getIntExpr(EVarInt.aw),
//                            EEngine.divCeiling(
//                                    EEngine.add(varMap.getIntExpr(EVarInt.ma), EEngine.num(32)),
//                                    EEngine.num(32))
//                    )
//            );
//
//            EExpr costEqCmem1 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.cost),
//                    EEngine.add(EEngine.cMem(varMap.getIntExpr(EVarInt.aw), varMap.getIntExpr(EVarInt.awnew)),
//                            EEngine.num(3))
//            );
//
//            EExpr valid1 = EEngine.checkValid(
//                    varMap.getIntExpr(EVarInt.size),
//                    EEngine.sub(varMap.getIntExpr(EVarInt.size), 1));
//
//            EExpr maMod32Eq01 = EEngine.eq(EEngine.mod(varMap.getIntExpr(EVarInt.ma), EEngine.num(32)), EEngine.num(0));
//            EExpr memWord1 = pred.memPred(contractID, pc,
//                    varMap.getIntExpr(EVarInt.ma),
//                    varMap.getIntExpr(EVarInt.val0));
//
//            EExpr qand = EEngine.and(
//                    mState1,
//                    maEqSa1,
//                    //awNewEqMax1,
//                    costEqCmem1,
//                    valid1,
//                    maMod32Eq01,
//                    memWord1
//            );
//
//            EExpr notVal =
//                    EEngine.not(
//                            EEngine.eq(
//                                    varMap.getIntExpr(EVarInt.val0),
//                                    EEngine.num(0
//                                    ))
//
//                    );
//
//            EExpr q1 = EEngine.and(
//                    memWord1,
//                    notVal
//            );
//
//
//            EExpr hd = EEngine.and(
//                    //checkPrems
//                    //mState
//                    //maMod32Eq0
//                    //memWord
//            );
//
//
//            EExpr hr =
//
//                    pred.memPred(contractID, 25, EEngine.num(0), EEngine.num(0));
//
//            EExpr hl = EEngine.and(mState,
//                    EEngine.not(EEngine.eq(
//                            varMap.getIntExpr(EVarInt.size),
//                            EEngine.num(3)
//                    ))
//                    ,
//                    EEngine.not(EEngine.eq(
//                            EEngine.select(
//                                    varMap.getArrExpr(EVarArr.stack),
//                                    EEngine.sub(
//                                            varMap.getIntExpr(EVarInt.size),
//                                            EEngine.num(2))
//                            ),
//                            EEngine.num(96)
//                    ))
//            );
//
//            EExpr hrrr = EEngine.and(mState,
//
//                    EEngine.eq(
//                            EEngine.select(
//                                    varMap.getArrExpr(EVarArr.stack),
//                                    EEngine.sub(
//                                            varMap.getIntExpr(EVarInt.size),
//                                            EEngine.num(2))
//                            ),
//                            EEngine.num(0)
//                    )
//            );
//
//            EExpr l =
//                    EEngine.and(
//                            pred.memPred(contractID, 26, EEngine.num(96), varMap.getIntExpr(EVarInt.va)),
//                            EEngine.not(EEngine.eq(varMap.getIntExpr(EVarInt.va),
//                                    EEngine.num(0)))
//                    );
//
//            EExpr l2 =
//
//                    pred.memPred(contractID, 8, EEngine.num(64), varMap.getIntExpr(EVarInt.va));
//
//            EExpr h = EEngine.and(mState,
//                    EEngine.eq(
//                            EEngine.select(
//                                    varMap.getArrExpr(EVarArr.stack),
//                                    EEngine.num(1)
//                            ),
//                            varMap.getIntExpr(EVarInt.val0)
//                    )
//            );
//
//            //EExpr expCost3 = pred.expCost(varMap.getIntExpr(EVarInt.val0), varMap.getIntExpr(EVarInt.val1));
//
//
//            // MSTORE
//            pc = 4;
//
//            EExpr h2, b2;
//
//            EExpr mState2 = pred.mStatePred(contractID, pc,
//                    varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//            EExpr maEqSa2 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.ma),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1)))
//            );
//
//            EExpr vEqSa2 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.va),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(2)))
//            );
//
//            // simple case
//            EExpr div2 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.k),
//                    EEngine.add(
//                            EEngine.divCeiling(varMap.getIntExpr(EVarInt.ma), EEngine.num(32)),
//                            EEngine.num(1)
//                    )
//            );
//
//            EExpr awGeDiv2 =
//                    EEngine.ge(
//                            varMap.getIntExpr(EVarInt.aw),
//                            varMap.getIntExpr(EVarInt.k)
//                    );
//
//            EExpr costEqCmemSimple2 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.cost),
//                    EEngine.num(3));
//
//            //complex case
//
//            EExpr awLtDiv2 =
//                    EEngine.lt(
//                            varMap.getIntExpr(EVarInt.aw),
//                            varMap.getIntExpr(EVarInt.k));
//
//            EExpr costEqCmemComplex2 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.cost),
//                    EEngine.add(
//                            EEngine.cMem(varMap.getIntExpr(EVarInt.aw), varMap.getIntExpr(EVarInt.k)),
//                            EEngine.num(3)
//                    )
//            );
//
//            EExpr valid2 = EEngine.checkValid(
//                    varMap.getIntExpr(EVarInt.size),
//                    EEngine.sub(varMap.getIntExpr(EVarInt.size), 2));
//
//
//            EExpr checkSimple2 = EEngine.and(
//                    mState2
//                    //maEqSa2,
//                    //vEqSa2
//                    //awNewEqMax,
//                    //div2,
//                    //awGeDiv2,
//                    //costEqCmemSimple2,
//                    //valid2
//            );
//
//
//            /*EExpr checkPremsSimple2 = pred.checkPremsMSTOREPredSimple(contractID, pc, varMap.getIntExpr(EVarInt.g), varMap.getIntExpr(EVarInt.cost), varMap.getIntExpr(EVarInt.ma),
//                    varMap.getIntExpr(EVarInt.va), varMap.getIntExpr(EVarInt.aw));*/
//
//            //b2 = checkPremsSimple2;
//
//            //mRules.add(EEngine.implies(h2, b2));
//
//            EExpr checkComplex2 = EEngine.and(
//                    mState2,
//                    maEqSa2,
//                    vEqSa2,
//                    //awNewEqMax,
//                    div2,
//                    awLtDiv2,
//                    costEqCmemComplex2,
//                    valid2
//            );
//
//
//            /*EExpr checkPremsComplex2 = pred.checkPremsMSTOREPredComplex(contractID, pc, varMap.getIntExpr(EVarInt.g), varMap.getIntExpr(EVarInt.cost), varMap.getIntExpr(EVarInt.ma),
//                    varMap.getIntExpr(EVarInt.va), varMap.getIntExpr(EVarInt.k));*/
//
//            //b2 = checkPremsComplex2;
//
//            //mRules.add(EEngine.implies(checkComplex2, b2));
//
//            EExpr h2simple = EEngine.and(mState2,
//                    checkSimple2
//            );
//
//            EExpr h2complex = EEngine.and(mState2,
//                    maEqSa2,
//                    vEqSa2,
//                    //awNewEqMax,
//                    div2,
//                    awLtDiv2,
//                    costEqCmemComplex2,
//                    valid2
//            );
//
//
//            //END MSTORE
//
//            EExpr mStateAw = EEngine.and(pred.mStatePred(contractID, pc, varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw)),
//                    EEngine.not(EEngine.eq(varMap.getIntExpr(EVarInt.aw), EEngine.num(3)))
//            );
//
//            EExpr preStor = pred.storPred(contractID, pc,
//                    varMap.getIntExpr(EVarInt.a),
//                    varMap.getIntExpr(EVarInt.posStor),
//                    varMap.getIntExpr(EVarInt.vaStor));
//
//
//            EExpr mState3 = pred.mStatePred(contractID, pc,
//                    varMap.getIntExpr(EVarInt.size),
//                    varMap.getArrExpr(EVarArr.stack),
//                    varMap.getIntExpr(EVarInt.aw));
//
//            EExpr qstore = EEngine.and(
//                    preStor,
//                    mState3
//            );
//
//            //MLOAD
//            EExpr h4, b4;
//            pc = 97;
//
//            EExpr mState4 = pred.mStatePred(contractID, pc, varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//            EExpr maEqSa4 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.ma),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1)))
//            );
//
//            // simple case
//
//            EExpr div4 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.k),
//                    EEngine.divCeiling(
//                            EEngine.add(varMap.getIntExpr(EVarInt.ma), EEngine.num(32)),
//                            EEngine.num(32))
//            );
//
//            EExpr awGeDiv4 =
//                    EEngine.ge(
//                            varMap.getIntExpr(EVarInt.aw),
//                            varMap.getIntExpr(EVarInt.k)
//                    );
//
//            EExpr costEqCmemSimple4 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.cost),
//                    EEngine.num(3));
//
//            //complex case
//
//            EExpr awLtDiv4 =
//                    EEngine.lt(
//                            varMap.getIntExpr(EVarInt.aw),
//                            varMap.getIntExpr(EVarInt.k));
//
//            EExpr costEqCmemComplex4 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.cost),
//                    EEngine.add(EEngine.cMem(varMap.getIntExpr(EVarInt.aw), varMap.getIntExpr(EVarInt.k)),
//                            EEngine.num(3))
//            );
//
//            EExpr valid4 = EEngine.checkValid(
//                    varMap.getIntExpr(EVarInt.size),
//                    EEngine.sub(varMap.getIntExpr(EVarInt.size), 1));
//
//
//            EExpr h4simple = EEngine.and(
//                    mState4,
//                    maEqSa4,
//                    div4,
//                    awGeDiv4,
//                    costEqCmemSimple4,
//                    valid4
//            );
//
//            h4 = EEngine.and(
//                    mState4,
//                    maEqSa4,
//                    div4,
//                    awLtDiv4,
//                    costEqCmemComplex4,
//                    valid4
//            );
//
//            EExpr maMod32Eq04 = EEngine.eq(EEngine.mod(varMap.getIntExpr(EVarInt.ma), EEngine.num(32)), EEngine.num(0));
//            EExpr memWord4 =
//                    pred.memPred(contractID, pc,
//                            varMap.getIntExpr(EVarInt.ma), varMap.getIntExpr(EVarInt.val0));
//
//            EExpr h4query = EEngine.and(
//                    h4simple,
//                    //maMod32Eq04,
//                    memWord4
//            );
//            //MLOAD END
//
//            pc = 17;
//            mState = pred.mStatePred(contractID, pc, varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//
//            h = EEngine.and(mState,
//                    EEngine.eq(
//                            EEngine.select(
//                                    varMap.getArrExpr(EVarArr.stack),
//                                    EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))
//                            ),
//                            varMap.getIntExpr(EVarInt.y)
//                    ),
//                    EEngine.not(
//                            EEngine.eq(
//                                    EEngine.num(0),
//                                    varMap.getIntExpr(EVarInt.y)
//                            )
//                    )
//            );
//
//            EExpr rez = EEngine.num(0);
//            for (int i = 0; i < 10; i++) {
//                rez = EEngine.add(rez, varMap.getIntExpr(EVarInt.gp));
//            }
//
//            // EExpr expCost = pred.expCost(varMap.getIntExpr(EVarInt.y), varMap.getIntExpr(EVarInt.val0));
//
//            //EXP
//
//            EExpr h5, b5;
//
//            EExpr mState5 = pred.mStatePred(contractID, pc,
//                    varMap.getIntExpr(EVarInt.size),
//                    varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//
//            EExpr valid5 = EEngine.checkValid(
//                    varMap.getIntExpr(EVarInt.size),
//                    EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(2))
//            );
//
//            EExpr x5 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.x),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack),
//                            EEngine.sub(varMap.getIntExpr(EVarInt.size), 1)));
//
//            EExpr y5 = EEngine.eq(
//                    varMap.getIntExpr(EVarInt.y),
//                    EEngine.select(varMap.getArrExpr(EVarArr.stack),
//                            EEngine.sub(varMap.getIntExpr(EVarInt.size), 2)));
//
//            EExpr costSimple5 = EEngine.and(
//                    EEngine.eq(varMap.getIntExpr(EVarInt.y), EEngine.num(0)),
//                    EEngine.eq(varMap.getIntExpr(EVarInt.cost), EEngine.num(10))
//            );
//
//        /*EExpr costComplex = EEngine.and(
//                EEngine.not(EEngine.eq(varMap.getIntExpr(EVarInt.y), EEngine.num(0))),
//                EEngine.eq(varMap.getIntExpr(EVarInt.cost),
//                        EEngine.add(EEngine.num(20), EEngine.mul(EEngine.num(10), EEngine.log256Floor(varMap.getIntExpr(EVarInt.y))))
//                ));*/
//
//            EExpr rez5 = EEngine.num(0);
//            for (int i = 0; i < 10; i++) {
//                rez = EEngine.add(rez, varMap.getIntExpr(EVarInt.cex));
//            }
//
//            EExpr costComplex5 = EEngine.and(
//                    EEngine.not(EEngine.eq(varMap.getIntExpr(EVarInt.y), EEngine.num(0))),
//                    EEngine.eq(varMap.getIntExpr(EVarInt.cost),
//                            EEngine.add(EEngine.num(20), rez))
//            );
//
//        /*EExpr cost = EEngine.ite(EEngine.eq(varMap.getIntExpr(EVarInt.y), EEngine.num(0)),
//                        EEngine.num(10),
//                        EEngine.add(EEngine.num(10),
//                                EEngine.mul(EEngine.num(10), EEngine.add(EEngine.num(1), EEngine.log256Floor(varMap.getIntExpr(EVarInt.y))))))));*/
//
//            h5 = EEngine.and(
//                    mState5,
//                    valid5,
//                    x5,
//                    y5,
//                    costSimple5
//            );
//
//            /*EExpr checkPremsPredSimple5 = pred.checkPremsEXPPred(contractID, pc,
//                    varMap.getIntExpr(EVarInt.g), varMap.getIntExpr(EVarInt.x), varMap.getIntExpr(EVarInt.y), varMap.getIntExpr(EVarInt.cost),
//                    varMap.getIntExpr(EVarInt.gc), varMap.getIntExpr(EVarInt.gas),  varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//*/
//            //b = checkPremsPredSimple5;
//
//            //mRules.add(EEngine.implies(h, b));
//
//            EExpr h5complex = EEngine.and(
//                    mState5,
//                    valid5,
//                    x5,
//                    y5,
//                    costComplex5
//                    // pred.expCost(varMap.getIntExpr(EVarInt.y), varMap.getIntExpr(EVarInt.cex))
//            );
//
//            EExpr preMem5 = pred.memPred(contractID, pc, varMap.getIntExpr(EVarInt.posmem), varMap.getIntExpr(EVarInt.va));
//
//            /*EExpr checkPremsPredComplex = pred.checkPremsEXPPred(contractID, pc,
//                    varMap.getIntExpr(EVarInt.g), varMap.getIntExpr(EVarInt.x), varMap.getIntExpr(EVarInt.y), varMap.getIntExpr(EVarInt.cost),
//                    varMap.getIntExpr(EVarInt.gc), varMap.getIntExpr(EVarInt.gas),  varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//*/
//            ///
//
//            pc = 18;
//
//            mState = pred.mStatePred(contractID, pc, varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack), varMap.getIntExpr(EVarInt.aw));
//
//            EExpr mem = pred.memPred(contractID, pc, varMap.getIntExpr(EVarInt.posmem), varMap.getIntExpr(EVarInt.va));
//
//
//            final ArrayList<BoolExpr> rules = new ArrayList<>();
//            final ArrayList<FuncDecl> funcs = new ArrayList<>();
//            //initialize Z3 engine and context
//            final HashMap<String, String> cfg = new HashMap<>();
//            final Context ctx = new Context(cfg);
//            initialise();
//            final BoolSort bool = ctx.mkBoolSort();
//            final IntSort intSort = ctx.mkIntSort();
//            final ArraySort arraySort = ctx.mkArraySort(intSort, intSort);
//            final Var var = new Var(ctx, gasLimit, intSort, GUARD);
//            final Engine engine = new Engine(ctx, var.getGaslimit(), maxEvmValue);
//            //initialize encoder
//            final Encoder encoder = new Encoder(ctx, engine, var, intSort, bool, arraySort, rules, funcs, GUARD);
//            encoder.encode(mRules);
//
//            BoolExpr query = encoder.encodeQuery(checkSimple2);
//
//            //process query
//            LOGGER.info("Your query is: " + query.toString());
//            long querystartTime = System.currentTimeMillis();
//            final Fixedpoint temp = ctx.mkFixedpoint();
//            for (BoolExpr rule : rules) {
//                try {
//                    temp.addRule(rule, null);
//                } catch (Z3Exception e) {
//                    e.printStackTrace();
//                }
//            }
//            for (FuncDecl func : funcs) {
//                temp.registerRelation(func);
//                Sym[] symbols = new Sym[]{ctx.mkSymbol("interval_relation"),
//                        ctx.mkSymbol("bound_relation")};
//                temp.setPredicateRepresentation(func, symbols);
//            }
//            Status result = temp.query(query);
//            String answer = temp.getAnswer().toString();
//            long querystopTime = System.currentTimeMillis();
//            long elapsedTime = querystopTime - querystartTime;
//
//                /*
//			     * Apparently the Z3 wrapper is not handling the memory correctly,
//			     * need to GC manually. See:
//			     * http://stackoverflow.com/questions/24188626/performance-issues-
//			     * about-z3-for-java#comment37349014_24190067
//			     */
//
//
//            if (counter % 50 == 0) {
//                System.gc();
//            }
//
//            counter++;
//
//            LOGGER.info("Your query is processed in: " + elapsedTime + "ms and the result is: " + result.toString());
//            //LOGGER.info("Assigment is " + answer);
//            //}
//
//        }
    }

    public void ExecuteTestQueries(final int GUARD,
                                   final int contractID) throws ExecutionException, InterruptedException {
        int counter = 0;
        Iterator it = internalByteCode.entrySet().iterator();
        Map<EExpr, Integer> queries = new LinkedHashMap<>();
        EExpr queryA;
        int sat = "SATISFIABLE".hashCode();
        int unsat = "UNSATISFIABLE".hashCode();
        //query generation

        // General Queries (for all): check the stack and memory
        while (it.hasNext()) {
            Map.Entry<Integer, InternalRepresentation> pair = (Map.Entry<Integer, InternalRepresentation>) it.next();

            if (memBound){
                queries.put(
                        pred.mStatePredMem(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.size),
                                varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                                0, varMap.getMem()), sat);
            }
            else{
                queries.put(
                        pred.mStatePred(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.size),
                                varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                                0), sat);
            }


            if (!it.hasNext()) {
                if (memBound){
                    queries.put(
                            pred.mStatePredMem(Integer.toString(contractID), pair.getValue().getPc() + 1,  varMap.getIntExpr(EVarInt.size),
                                    varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                                    0, varMap.getMem()), sat);
                }
                else{
                    queries.put(
                            pred.mStatePred(Integer.toString(contractID), pair.getValue().getPc() + 1,  varMap.getIntExpr(EVarInt.size),
                                    varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                                    0), sat);
                }
            }
        }

        // Queries specific for the bytecode
        /*
         Test contracts in the file are enumerated starting from 0, the names are %contractNumber_bytecode.
         If the next command pc is unknown its assumed to be pc + 1
         */
        switch (contractID){
            // 0_PUSH1
            case 0:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 1, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 1, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }

                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num(96)
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num(96)
                                ))
                        ), unsat
                );
                break;
            // 1_PUSH32
            case 1:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 1, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 1, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                             0);
                }

                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("1159549501734451472094670738960689470802050671352334511443330939262888126535")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("1159549501734451472094670738960689470802050671352334511443330939262888126535")
                                ))
                        ), unsat
                );
                break;
            // 2_ADD
            case 2:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("182")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("182")
                                ))
                        ), unsat
                );
                break;
            // 3_MUL
            case 3:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }

                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("8256")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("8256")
                                ))
                        ), unsat
                );
                break;
            // 4_SUB
            case 4:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5,  varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5,  varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("10")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("10")
                                ))
                        ), unsat
                );
                break;
            // 5_DIV
            case 5:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("1")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("1")
                                ))
                        ), unsat
                );
                break;
            // 6_EXP
            /*case 6:
                queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.g),
                        varMap.getIntExpr(EVarInt.gc), varMap.getIntExpr(EVarInt.gas), varMap.getIntExpr(EVarInt.size),
                        varMap.getArrExpr(EVarArr.stack),
                        varMap.getIntExpr(EVarInt.aw));
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.select(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("9216")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.select(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("9216")
                                ))
                        ), unsat
                );
                break;*/
            // 7_EQ_FALSE
            case 7:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }

                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                ))
                        ), unsat
                );
                break;
            // 8_EQ_TRUE
            case 8:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("1")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("1")
                                ))
                        ), unsat
                );
                break;
            // 9_ISZERO_FALSE
            case 9:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                ))
                        ), unsat
                );
                break;
            // 10_ISZERO_TRUE
            case 10:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("1")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("1")
                                ))
                        ), unsat
                );
                break;
            // 11_AND
            case 11:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("64")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("64")
                                ))
                        ), unsat
                );
                break;
            // 12_DUP1
            case 12:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 3, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 3, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("96")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("96")
                                ))
                        ), unsat
                );
                break;
            // 13_DUP16
            case 13:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 33, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 33, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                ))
                        ), unsat
                );
                break;
            // 14_SWAP1
            case 14:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("96")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("96")
                                ))
                        ), unsat
                );
                break;
            // 15_SWAP16
            case 15:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 35, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 35, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                ))
                        ), unsat
                );
                break;
            // 16_POP
            case 16:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 5, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("96")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("96")
                                ))
                        ), unsat
                );
                break;
            // 17_CALLDATALOAD_EQ
            case 17:
                if (memBound){
                    queryA = pred.mStatePredMem(Integer.toString(contractID), 6, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0, varMap.getMem());
                }
                else{
                    queryA = pred.mStatePred(Integer.toString(contractID), 6, varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                            0);
                }
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                )
                        ), sat
                );
                queries.put(
                        EEngine.and(
                                queryA,
                                EEngine.not(EEngine.eq(
                                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                        EEngine.num("0")
                                ))
                        ), sat
                );
                break;
        }

        //process queries
        Iterator itq = queries.entrySet().iterator();
        while (itq.hasNext()) {
            Map.Entry<EExpr, Integer> pair = (Map.Entry<EExpr, Integer>) itq.next();
            EExpr eQuery = pair.getKey();
            int res = pair.getValue();
            final ArrayList<BoolExpr> rules = new ArrayList<>();
            final ArrayList<FuncDecl> funcs = new ArrayList<>();
            //initialize Z3 engine and context
            final HashMap<String, String> cfg = new HashMap<>();
            final Context ctx = new Context(cfg);
            initialise();
            final BoolSort bool = ctx.mkBoolSort();
            final IntSort intSort = ctx.mkIntSort();
            final ArraySort arraySortInt = ctx.mkArraySort(intSort, intSort);
            final ArraySort arraySortBool = ctx.mkArraySort(intSort, bool);
            final Var var = new Var(ctx, intSort, bool, arraySortInt, arraySortBool, GUARD);
            final Engine engine = new Engine(ctx);
            //initialize encoder
            final Encoder encoder = new Encoder(ctx, engine, var, intSort, bool, arraySortInt, arraySortBool, rules, funcs, GUARD);
            encoder.encode(mRules);
            BoolExpr query = encoder.encodeQuery(eQuery);
            LOGGER.info("Your query is: " + query.toString());
            long querystartTime = System.currentTimeMillis();
            final Fixedpoint temp = ctx.mkFixedpoint();
            for (BoolExpr rule : rules) {
                try {
                    temp.addRule(rule, null);
                } catch (Z3Exception e) {
                    e.printStackTrace();
                }
            }
            for (FuncDecl func : funcs) {
                temp.registerRelation(func);
                Symbol[] symbols = new Symbol[]{ctx.mkSymbol("interval_relation"),
                        ctx.mkSymbol("bound_relation")};
                temp.setPredicateRepresentation(func, symbols);
            }
            Status result = temp.query(query);
            long querystopTime = System.currentTimeMillis();
            long elapsedTime = querystopTime - querystartTime;
            if (counter % 50 == 0) {
                System.gc();
            }
            counter++;
            LOGGER.info("Your query is processed in: " + elapsedTime + "ms and the result is: " + result.toString());
            if (result.toString().hashCode() != res){
                LOGGER.error("TEST NOT PASSED!");
            }
        }
    }

    public void ExecuteQueries(final int GUARD,
                               final int contractID) throws ExecutionException, InterruptedException {
        int counter = 0;
        Iterator it = internalByteCode.entrySet().iterator();
        while(it.hasNext()){
            Map.Entry<Integer, InternalRepresentation> pair = (Map.Entry<Integer, InternalRepresentation>) it.next();

            if (pair.getValue().getPc() < 101) continue;
                final ArrayList<BoolExpr> rules = new ArrayList<>();
                final ArrayList<FuncDecl> funcs = new ArrayList<>();
                //initialize Z3 engine and context
                final HashMap<String, String> cfg = new HashMap<>();
                final Context ctx = new Context(cfg);
                initialise();
                final BoolSort bool = ctx.mkBoolSort();
                final IntSort intSort = ctx.mkIntSort();
                final ArraySort arraySortInt = ctx.mkArraySort(intSort, intSort);
                final ArraySort arraySortBool = ctx.mkArraySort(intSort, bool);
                final Var var = new Var(ctx, intSort, bool, arraySortInt, arraySortBool, GUARD);
                final Engine engine = new Engine(ctx);
                //initialize encoder
                final Encoder encoder = new Encoder(ctx, engine, var, intSort, bool, arraySortInt, arraySortBool, rules, funcs, GUARD);
                encoder.encode(mRules);
                //create query
                /*BoolExpr query = encoder.encodeQuery(pred.mStatePred(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.g),
                        varMap.getIntExpr(EVarInt.gc), varMap.getIntExpr(EVarInt.gas), varMap.getIntExpr(EVarInt.size),
                        varMap.getArrExpr(EVarArr.stack),
                        varMap.getIntExpr(EVarInt.aw)));*/

                /*BoolExpr query = encoder.encodeQuery(pred.memPred(Integer.toString(contractID), pair.getValue().getPc(),
                        varMap.getIntExpr(EVarInt.val1),
                        varMap.getIntExpr(EVarInt.val0)));*/

            //BoolExpr query = encoder.encodeQuery(pred.gStatePred(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.a), varMap.getIntExpr(EVarInt.n), varMap.getIntExpr(EVarInt.b), 0));

            /*EExpr exenvPredicate = pred.exenvPred(
                    Integer.toString(contractID),
                    varMap.getIntExpr(EVarInt.a),
                    varMap.getIntExpr(EVarInt.i),
                    varMap.getIntExpr(EVarInt.cd),
                    varMap.getIntExpr(EVarInt.va),
                    varMap.getIntExpr(EVarInt.inputsize));

            BoolExpr query = encoder.encodeQuery(
                    EEngine.and(
                    pred.mStatePred(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.size),
                            varMap.getArrExpr(EVarArr.stack),
                            varMap.getIntExpr(EVarInt.aw), varMap.getMem()),
                            exenvPredicate)
            );*/

            int cd = 0;

            EExpr mst = pred.mStatePred(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.size),
                    varMap.getArrExpr(EVarArr.stack),  varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                    cd);
            EExpr gst = pred.gStatePred(Integer.toString(contractID), pair.getValue().getPc(),  varMap.getIntExpr(EVarInt.n), varMap.getIntExpr(EVarInt.b), cd);
            EExpr str = pred.storPred(Integer.toString(contractID), pair.getValue().getPc(),  varMap.getIntExpr(EVarInt.posStor), varMap.getIntExpr(EVarInt.vaStor),
                    varMap.getTaintExpr(Taint.taintS), varMap.getSymbolicExpr(Sym.symS), cd);
            EExpr str0 = pred.storPred(Integer.toString(contractID), pair.getValue().getPc(),
                    EEngine.num("78338746147236970124700731725183845421594913511827187288591969170390706184117"), EEngine.num(1),
                    varMap.getTaintExpr(Taint.taintS), varMap.getSymbolicExpr(Sym.symS), cd);
            EExpr mem = pred.memPred(Integer.toString(contractID), pair.getValue().getPc(), EEngine.num(64), varMap.getIntExpr(EVarInt.va),
                    varMap.getTaintExpr(Taint.taintM), varMap.getSymbolicExpr(Sym.symM), cd);


            BoolExpr query;

            if (memBound){
                query = encoder.encodeQuery(
                        pred.mStatePredMem(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.size),
                                varMap.getArrExpr(EVarArr.stack),  varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                                1, varMap.getMem()));
            }
            else{

                EExpr queryA = pred.mStatePred(Integer.toString(contractID), 128, varMap.getIntExpr(EVarInt.size),
                        varMap.getArrExpr(EVarArr.stack), varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                        0);
                /*EExpr check = EEngine.and(
                        queryA,
                        EEngine.not(EEngine.eq(
                                EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                EEngine.num(0)
                        ))
                );*/
                /*EExpr check = EEngine.and(
                        mst,
                        str
                );*/
                /*EExpr check = EEngine.and(
                        queryA,
                        EEngine.eq(
                                EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1))),
                                EEngine.num(1)
                        )
                );*/
                //query = encoder.encodeQuery(check);
                query = encoder.encodeQuery(mst);
                /*query = encoder.encodeQuery(
                        pred.mStatePred(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.size),
                                varMap.getArrExpr(EVarArr.stack),  varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS), varMap.getTaintExpr(Taint.taint),
                                1));*/
                /*EExpr maEqSa = EEngine.eq(
                        varMap.getIntExpr(EVarInt.ma),
                        EEngine.selectInt(varMap.getArrExpr(EVarArr.stack), EEngine.sub(varMap.getIntExpr(EVarInt.size), EEngine.num(1)))
                );

                EExpr maMod32Eq0 = EEngine.eq(EEngine.mod(varMap.getIntExpr(EVarInt.ma), EEngine.num(32)), EEngine.num(0));
                EExpr memWord = pred.memPred(Integer.toString(contractID), pair.getValue().getPc(),
                        varMap.getIntExpr(EVarInt.ma), varMap.getIntExpr(EVarInt.val0), varMap.getTaintExpr(Taint.taintM), varMap.getSymbolicExpr(Sym.symM), cd);
                EExpr mState = pred.mStatePred(Integer.toString(contractID), pair.getValue().getPc(), varMap.getIntExpr(EVarInt.size), varMap.getArrExpr(EVarArr.stack),
                        varMap.getArrTExpr(EVarArrT.stackT), varMap.getArrSExpr(EVarArrS.stackS),
                        varMap.getTaintExpr(Taint.taint),
                        cd);
                query = encoder.encodeQuery(EEngine.and(
                        mState,
                        //maEqSa,
                        //maMod32Eq0
                        memWord
                ));*/
                 /*query = encoder.encodeQuery(
                         EEngine.and(
                                 mst,
                                 gst,
                                 str
                                 ,mem
                         )
                 );*/
            }


               /* BoolExpr query = encoder.encodeQuery(pred.storPred(
                        Integer.toString(contractID),
                        pair.getValue().getPc(),
                        varMap.getIntExpr(EVarInt.a),
                        varMap.getIntExpr(EVarInt.pos),
                        varMap.getIntExpr(EVarInt.v)));*/
                //process query
                LOGGER.info("Your query is: " + query.toString());
                long querystartTime = System.currentTimeMillis();
                final Fixedpoint temp = ctx.mkFixedpoint();
                for (BoolExpr rule: rules) {
                    try {
                        temp.addRule(rule, null);
                    }
                    catch (Z3Exception e){
                        e.printStackTrace();
                    }
                }
                for (FuncDecl func: funcs) {
                    temp.registerRelation(func);
                    Symbol[] symbols = new Symbol[]{ctx.mkSymbol("interval_relation"),
                            ctx.mkSymbol("bound_relation")};
                    temp.setPredicateRepresentation(func, symbols);
                }
                Status result = temp.query(query);

                long querystopTime = System.currentTimeMillis();
                long elapsedTime = querystopTime - querystartTime;

                /*
			     * Apparently the Z3 wrapper is not handling the memory correctly,
			     * need to GC manually. See:
			     * http://stackoverflow.com/questions/24188626/performance-issues-
			     * about-z3-for-java#comment37349014_24190067
			     */


                if (counter % 50 == 0) {
                    System.gc();
                }

                counter++;

                LOGGER.info("Your query is processed in: " + elapsedTime + "ms and the result is: " + result.toString());
            }
        //}
    }

    public void CheckReentrancy(final int GUARD,
                               final int contractID) throws ExecutionException, InterruptedException {
            int counter = 0;
        LOGGER.info("Checking re-entrancy...");

        for (EExpr mQuery: mQueriesRe) {
                final ArrayList<BoolExpr> rules = new ArrayList<>();
                final ArrayList<FuncDecl> funcs = new ArrayList<>();
                //initialize Z3 engine and context
                final HashMap<String, String> cfg = new HashMap<>();
                final Context ctx = new Context(cfg);
                initialise();
                final BoolSort bool = ctx.mkBoolSort();
                final IntSort intSort = ctx.mkIntSort();
                final ArraySort arraySortInt = ctx.mkArraySort(intSort, intSort);
                final ArraySort arraySortBool = ctx.mkArraySort(intSort, bool);
                final Var var = new Var(ctx, intSort, bool, arraySortInt, arraySortBool, GUARD);
                final Engine engine = new Engine(ctx);
                //initialize encoder
                final Encoder encoder = new Encoder(ctx, engine, var, intSort, bool, arraySortInt, arraySortBool, rules, funcs, GUARD);
                encoder.encode(mRules);
                BoolExpr query = encoder.encodeQuery(mQuery);
                //process query
                LOGGER.info("Your query is: " + query.toString());
                long querystartTime = System.currentTimeMillis();
                final Fixedpoint temp = ctx.mkFixedpoint();
                for (BoolExpr rule : rules) {
                    try {
                        temp.addRule(rule, null);
                    } catch (Z3Exception e) {
                        e.printStackTrace();
                    }
                }
                for (FuncDecl func : funcs) {
                    temp.registerRelation(func);
                    Symbol[] symbols = new Symbol[]{ctx.mkSymbol("interval_relation"),
                            ctx.mkSymbol("bound_relation")};
                    temp.setPredicateRepresentation(func, symbols);
                }

                final Status result = temp.query(query);
                long querystopTime = System.currentTimeMillis();
                long elapsedTime = querystopTime - querystartTime;
                LOGGER.info("Your query is processed in: " + elapsedTime + "ms and the result is: " + result.toString());
                if (result.toString().equals("SATISFIABLE"))
                    break;

                /*class SolveQuery implements Runnable {
                    public void run() {
                        final Status result = temp.query(query);
                        long querystopTime = System.currentTimeMillis();
                        long elapsedTime = querystopTime - querystartTime;
                        LOGGER.info("Your query is processed in: " + elapsedTime + "ms and the result is: " + result.toString());
                    }
                }
                ExecutorService executor = Executors.newSingleThreadExecutor();
                executor.execute(new SolveQuery());
                executor.awaitTermination(timeBound, TimeUnit.SECONDS);
                if (!executor.isTerminated() && !executor.isShutdown()) {
                    executor.shutdown();
                }*/
                if (counter % 50 == 0) {
                    System.gc();
                }

                counter++;
            } }
        //}

    public void CheckDependency(final int GUARD,
                                final int contractID) throws ExecutionException, InterruptedException {
        int counter = 0;
        LOGGER.info("Checking dependency...");

        for (EExpr mQuery: mQueriesDe) {
            final ArrayList<BoolExpr> rules = new ArrayList<>();
            final ArrayList<FuncDecl> funcs = new ArrayList<>();
            //initialize Z3 engine and context
            final HashMap<String, String> cfg = new HashMap<>();
            final Context ctx = new Context(cfg);
            initialise();
            final BoolSort bool = ctx.mkBoolSort();
            final IntSort intSort = ctx.mkIntSort();
            final ArraySort arraySortInt = ctx.mkArraySort(intSort, intSort);
            final ArraySort arraySortBool = ctx.mkArraySort(intSort, bool);
            final Var var = new Var(ctx, intSort, bool, arraySortInt, arraySortBool, GUARD);
            final Engine engine = new Engine(ctx);
            //initialize encoder
            final Encoder encoder = new Encoder(ctx, engine, var, intSort, bool, arraySortInt, arraySortBool, rules, funcs, GUARD);
            encoder.encode(mRules);
            BoolExpr query = encoder.encodeQuery(mQuery);
            //process query
            LOGGER.info("Your query is: " + query.toString());
            long querystartTime = System.currentTimeMillis();
            final Fixedpoint temp = ctx.mkFixedpoint();
            for (BoolExpr rule : rules) {
                try {
                    temp.addRule(rule, null);
                } catch (Z3Exception e) {
                    e.printStackTrace();
                }
            }
            for (FuncDecl func : funcs) {
                temp.registerRelation(func);
                Symbol[] symbols = new Symbol[]{ctx.mkSymbol("interval_relation"),
                        ctx.mkSymbol("bound_relation")};
                temp.setPredicateRepresentation(func, symbols);
            }

            final Status result = temp.query(query);
            long querystopTime = System.currentTimeMillis();
            long elapsedTime = querystopTime - querystartTime;
            LOGGER.info("Your query is processed in: " + elapsedTime + "ms and the result is: " + result.toString());
            if (result.toString().equals("SATISFIABLE"))
                break;

                /*class SolveQuery implements Runnable {
                    public void run() {
                        final Status result = temp.query(query);
                        long querystopTime = System.currentTimeMillis();
                        long elapsedTime = querystopTime - querystartTime;
                        LOGGER.info("Your query is processed in: " + elapsedTime + "ms and the result is: " + result.toString());
                    }
                }
                ExecutorService executor = Executors.newSingleThreadExecutor();
                executor.execute(new SolveQuery());
                executor.awaitTermination(timeBound, TimeUnit.SECONDS);
                if (!executor.isTerminated() && !executor.isShutdown()) {
                    executor.shutdown();
                }*/
            if (counter % 50 == 0) {
                System.gc();
            }

            counter++;
        } }
    //}
}
