package com.ethornium.z3;

import com.microsoft.z3.*;

import java.util.HashMap;
import java.util.Map;

public class Var {
    private final Context ctx;
    private final int GUARD;
    private final IntExpr c, pc, g, gas, size, aw, a, n, b, gc,
            //gaslimit,
            stacklimit, i, x, y, z,
            ma, awnew, v, sizeup, sizelow, posmem, va, cd, posinp, posStor, vaStor, jumpDest, bcond, cost,
            val0, val1, vnew,
            newG,newGas, stackAddress;
    private IntExpr varesult;
    private IntExpr returndatasize, aprime, inputsize, s, pos, poscom, codesize, com, wpos, wmem;
    private IntExpr gasTo, to, io, is, oo, os, cUpfront, cex, cGascap, CCall, ccase, idp, cp, k, gp, code, id;
    private ArrayExpr stack,initstack, newStack;
    private ArrayExpr stackT,initstackT, newStackT;
    private ArrayExpr stackS,initstackS, newStackS;
    private BoolExpr taint, sym, xt, yt, zt, rezt, xs, ys, zs, rezs, taintM, taintS, symM, symS;
    private IntSort intSort;
    private BoolSort boolSort;
    private ArraySort arraySort;
    private ArraySort arraySortBool;
    private Map<Integer, IntExpr> indexMapInt;
    private Map<Integer, ArrayExpr> indexMapArray;
    private Map<Integer, ArrayExpr> indexMapTaintArray;
    private Map<Integer, ArrayExpr> indexMapSymbolArray;
    private Map<Integer, BoolExpr> indexMapTaint;
    private Map<Integer, BoolExpr> indexMapSymbol;
    public Var(final Context ctx, final IntSort _intSort, final BoolSort _boolSort, final ArraySort _arraySort, final ArraySort _arraySortBool, final int GUARD) {
        this.GUARD = GUARD;
        indexMapInt = new HashMap<>();
        indexMapArray = new HashMap<>();
        indexMapTaintArray = new HashMap<>();
        indexMapSymbolArray = new HashMap<>();
        indexMapTaint = new HashMap<>();
        indexMapSymbol = new HashMap<>();
        this.ctx = ctx;
        this.intSort=_intSort;
        this.boolSort = _boolSort;
        this.arraySort = _arraySort;
        this.arraySortBool = _arraySortBool;

        this.c = (IntExpr) this.ctx.mkBound(0, intSort);
        indexMapInt.put(0, c);
        this.pc = (IntExpr) this.ctx.mkBound(1, intSort);
        indexMapInt.put(1, pc);
        this.g = (IntExpr) this.ctx.mkBound(2, intSort);
        indexMapInt.put(2, g);
        this.gas = (IntExpr) this.ctx.mkBound(3, intSort);
        indexMapInt.put(3, gas);
        this.size = (IntExpr) this.ctx.mkBound(4, intSort);
        indexMapInt.put(4, size);
        this.aw = (IntExpr) this.ctx.mkBound(5, intSort);
        indexMapInt.put(5, aw);
        this.a = (IntExpr) this.ctx.mkBound(6, intSort);
        indexMapInt.put(6, a);
        this.n = (IntExpr) this.ctx.mkBound(7, intSort);
        indexMapInt.put(7, n);
        this.b = (IntExpr) this.ctx.mkBound(8, intSort);
        indexMapInt.put(8, b);
        this.gc = (IntExpr) this.ctx.mkBound(9, intSort);
        indexMapInt.put(9, gc);
        this.i = (IntExpr) this.ctx.mkBound(10, intSort);
        indexMapInt.put(10, i);
        this.x = (IntExpr) this.ctx.mkBound(11, intSort);
        indexMapInt.put(11, x);
        this.y = (IntExpr) this.ctx.mkBound(12, intSort);
        indexMapInt.put(12, y);
        this.ma = (IntExpr) this.ctx.mkBound(13, intSort);
        indexMapInt.put(13, ma);
        this.awnew = (IntExpr) this.ctx.mkBound(14, intSort);
        indexMapInt.put(14, awnew);
        this.v = (IntExpr) this.ctx.mkBound(15, intSort);
        indexMapInt.put(15, v);
        this.sizeup = (IntExpr) this.ctx.mkBound(16, intSort);
        indexMapInt.put(16, sizeup);
        this.sizelow = (IntExpr) this.ctx.mkBound(17, intSort);
        indexMapInt.put(17, sizelow);
        this.posmem = (IntExpr) this.ctx.mkBound(18, intSort);
        indexMapInt.put(18, posmem);
        this.va = (IntExpr) this.ctx.mkBound(19, intSort);
        indexMapInt.put(19, va);
        this.cd = (IntExpr) this.ctx.mkBound(20, intSort);
        indexMapInt.put(20, cd);
        this.posinp = (IntExpr) this.ctx.mkBound(21, intSort);
        indexMapInt.put(21, posinp);
        this.posStor = (IntExpr) this.ctx.mkBound(22, intSort);
        indexMapInt.put(22, posStor);
        this.vaStor = (IntExpr) this.ctx.mkBound(23, intSort);
        indexMapInt.put(23, vaStor);
        this.jumpDest = (IntExpr) this.ctx.mkBound(24, intSort);
        indexMapInt.put(24, jumpDest);
        this.bcond = (IntExpr) this.ctx.mkBound(25, intSort);
        indexMapInt.put(25, bcond);
        this.cost = (IntExpr) this.ctx.mkBound(26, intSort);
        indexMapInt.put(26, cost);

        this.gasTo = (IntExpr) this.ctx.mkBound(30, intSort);
        indexMapInt.put(30, gasTo);
        this.to = (IntExpr) this.ctx.mkBound(31, intSort);
        indexMapInt.put(31, to);
        this.io = (IntExpr) this.ctx.mkBound(32, intSort);
        indexMapInt.put(32, io);
        this.is = (IntExpr) this.ctx.mkBound(33, intSort);
        indexMapInt.put(33, is);
        this.oo = (IntExpr) this.ctx.mkBound(34, intSort);
        indexMapInt.put(34, oo);
        this.os = (IntExpr) this.ctx.mkBound(35, intSort);
        indexMapInt.put(35, os);

        this.cUpfront = (IntExpr) this.ctx.mkBound(36, intSort);
        indexMapInt.put(36, cUpfront);
        this.cex = (IntExpr) this.ctx.mkBound(37, intSort);
        indexMapInt.put(37, cex);
        this.cGascap = (IntExpr) this.ctx.mkBound(38, intSort);
        indexMapInt.put(38, cGascap);
        this.CCall = (IntExpr) this.ctx.mkBound(39, intSort);
        indexMapInt.put(39, CCall);
        this.ccase = (IntExpr) this.ctx.mkBound(40, intSort);
        indexMapInt.put(40, ccase);
        this.idp = (IntExpr) this.ctx.mkBound(41, intSort);
        indexMapInt.put(41, idp);
        this.cp = (IntExpr) this.ctx.mkBound(42, intSort);
        indexMapInt.put(42, cp);
        this.k = (IntExpr) this.ctx.mkBound(43, intSort);
        indexMapInt.put(43, k);
        this.gp = (IntExpr) this.ctx.mkBound(44, intSort);
        indexMapInt.put(44, gp);
        this.code = (IntExpr) this.ctx.mkBound(45, intSort);
        indexMapInt.put(45, code);
        this.id = (IntExpr) this.ctx.mkBound(46, intSort);
        indexMapInt.put(46, id);
        this.z = (IntExpr) this.ctx.mkBound(47, intSort);
        indexMapInt.put(47, z);

        this.varesult = (IntExpr) this.ctx.mkBound(59, intSort);

        indexMapInt.put(59, varesult);
        this.returndatasize = (IntExpr) this.ctx.mkBound(60, intSort);
        indexMapInt.put(60, returndatasize);
        this.aprime = (IntExpr) this.ctx.mkBound(61, intSort);
        indexMapInt.put(61, aprime);
        this.inputsize = (IntExpr) this.ctx.mkBound(62, intSort);
        indexMapInt.put(62, inputsize);
        this.s = (IntExpr) this.ctx.mkBound(63, intSort);
        indexMapInt.put(63, s);
        this.pos = (IntExpr) this.ctx.mkBound(64, intSort);
        indexMapInt.put(64, pos);
        this.poscom = (IntExpr) this.ctx.mkBound(65, intSort);
        indexMapInt.put(65, poscom);
        this.codesize = (IntExpr) this.ctx.mkBound(66, intSort);
        indexMapInt.put(66, codesize);
        this.com = (IntExpr) this.ctx.mkBound(67, intSort);
        indexMapInt.put(67, com);
        this.wpos = (IntExpr) this.ctx.mkBound(68, intSort);
        indexMapInt.put(68, wpos);
        this.wmem = (IntExpr) this.ctx.mkBound(69, intSort);
        indexMapInt.put(69, wmem);

        //this.gaslimit = this.ctx.mkInt(gasLimit);
        //indexMapInt.put(89, gaslimit);

        this.stacklimit = this.ctx.mkInt(1024);
        indexMapInt.put(90, stacklimit);

        this.stack = (ArrayExpr) this.ctx.mkBound(70, arraySort);
        indexMapArray.put(70, stack);
        this.initstack = this.ctx.mkConstArray(intSort,ctx.mkInt(0));
        indexMapArray.put(91, initstack);


        this.val0 = (IntExpr) this.ctx.mkBound(80, intSort);
        indexMapInt.put(80, val0);
        this.val1 = (IntExpr) this.ctx.mkBound(81, intSort);
        indexMapInt.put(81, val1);
        this.vnew = (IntExpr) this.ctx.mkBound(82, intSort);
        indexMapInt.put(82, vnew);

        this.newG = (IntExpr) this.ctx.mkBound(83, intSort);
        indexMapInt.put(83, newG);
        this.newGas = (IntExpr) this.ctx.mkBound(84, intSort);
        indexMapInt.put(84, newGas);
        this.newStack = (ArrayExpr) this.ctx.mkBound(85, arraySort);
        indexMapArray.put(85, newStack);
        this.stackAddress = (IntExpr) this.ctx.mkBound(86, intSort);
        indexMapInt.put(86, stackAddress);

        this.newStackT = (ArrayExpr) this.ctx.mkBound(92, arraySortBool);
        indexMapTaintArray.put(92, newStackT);
        this.stackT = (ArrayExpr) this.ctx.mkBound(93, arraySortBool);
        indexMapTaintArray.put(93, stackT);
        this.initstackT = (ArrayExpr) this.ctx.mkBound(94, arraySortBool);
        this.initstackT = this.ctx.mkConstArray(intSort, ctx.mkBool(false));
        indexMapTaintArray.put(94, initstackT);

        this.newStackS = (ArrayExpr) this.ctx.mkBound(95, arraySortBool);
        indexMapSymbolArray.put(95, newStackS);
        this.stackS = (ArrayExpr) this.ctx.mkBound(96, arraySortBool);
        indexMapSymbolArray.put(96, stackS);
        this.initstackS = (ArrayExpr) this.ctx.mkBound(97, arraySortBool);
        this.initstackS = this.ctx.mkConstArray(intSort, ctx.mkBool(false));
        indexMapSymbolArray.put(97, initstackS);


        this.taint = (BoolExpr) this.ctx.mkBound(100, boolSort);
        indexMapTaint.put(100, taint);
        this.xt = (BoolExpr) this.ctx.mkBound(101, boolSort);
        indexMapTaint.put(101, xt);
        this.yt = (BoolExpr) this.ctx.mkBound(102, boolSort);
        indexMapTaint.put(102, yt);
        this.zt = (BoolExpr) this.ctx.mkBound(103, boolSort);
        indexMapTaint.put(103, zt);
        this.rezt = (BoolExpr) this.ctx.mkBound(104, boolSort);
        indexMapTaint.put(104, rezt);
        this.taintM = (BoolExpr) this.ctx.mkBound(105, boolSort);
        indexMapTaint.put(105, rezt);
        this.taintS= (BoolExpr) this.ctx.mkBound(106, boolSort);
        indexMapTaint.put(106, taintS);

        this.sym = (BoolExpr) this.ctx.mkBound(120, boolSort);
        indexMapSymbol.put(120, sym);
        this.xs = (BoolExpr) this.ctx.mkBound(121, boolSort);
        indexMapSymbol.put(121, xs);
        this.ys = (BoolExpr) this.ctx.mkBound(122, boolSort);
        indexMapSymbol.put(122, ys);
        this.zs = (BoolExpr) this.ctx.mkBound(123, boolSort);
        indexMapSymbol.put(123, zs);
        this.rezs = (BoolExpr) this.ctx.mkBound(124, boolSort);
        indexMapSymbol.put(124, rezs);
        this.symM = (BoolExpr) this.ctx.mkBound(125, boolSort);
        indexMapSymbol.put(125, symM);
        this.symS = (BoolExpr) this.ctx.mkBound(126, boolSort);
        indexMapSymbol.put(126, symS);

    }

    public IntExpr getVarInt(final int ind){
        return indexMapInt.get(ind);
    }

    public ArrayExpr getVarArr(final int ind){
        return indexMapArray.get(ind);
    }

    public ArrayExpr getValTaintArr(final int ind){
        return indexMapTaintArray.get(ind);
    }

    public ArrayExpr getValSymbolArr(final int ind){
        return indexMapSymbolArray.get(ind);
    }


    public BoolExpr getVarTaint(final int ind){
        return indexMapTaint.get(ind);
    }

    public BoolExpr getVarSymbol(final int ind){
        return indexMapSymbol.get(ind);
    }


    public IntExpr getNewG() { return newG; }

    public IntExpr getNewGas() { return newGas; }

    public ArrayExpr getNewStack() { return  newStack; }

    public  IntExpr getStackAddress() {return stackAddress; }

    public IntExpr getVnew() {
        return vnew;
    }

    public IntExpr getC() {
        return c;
    }

    public IntExpr getPc() {
        return pc;
    }

    public IntExpr getG() {
        return g;
    }

    public IntExpr getGas() {
        return gas;
    }

    public IntExpr getSize() {
        return size;
    }

    public IntExpr getAw() {
        return aw;
    }

    public IntExpr getA() {
        return a;
    }

    public IntExpr getN() {
        return n;
    }

    public IntExpr getB() {
        return b;
    }

    public IntExpr getGc() {
        return gc;
    }

    public IntExpr getI() {
        return i;
    }

    public IntExpr getX() {
        return x;
    }

    public IntExpr getY() {
        return y;
    }

    public IntExpr getV() {
        return v;
    }

    public IntExpr getMa() {
        return ma;
    }

    public IntExpr getAwnew() {
        return awnew;
    }

    //public IntExpr getGaslimit() {
    //    return gaslimit;
    //}

    public IntExpr getStacklimit() {
        return stacklimit;
    }

    public IntExpr getSizeup() {
        return sizeup;
    }

    public IntExpr getSizelow() {
        return sizelow;
    }

    public IntExpr getPosmem() {
        return posmem;
    }

    public IntExpr getVa() {
        return va;
    }

    public IntExpr getCd() {
        return cd;
    }

    public IntExpr getPosinp() {
        return posinp;
    }

    public IntExpr getPosStor() {
        return posStor;
    }

    public IntExpr getVaStor() {
        return vaStor;
    }

    public IntExpr getJumpDest() {
        return jumpDest;
    }

    public IntExpr getBcond() {
        return bcond;
    }

    public IntExpr getCost() {
        return cost;
    }

    public IntExpr getReturndatasize() {
        return returndatasize;
    }

    public IntExpr getAprime() {
        return aprime;
    }

    public IntExpr getInputsize() {
        return inputsize;
    }

    public IntExpr getS() {
        return s;
    }

    public IntExpr getPos() {
        return pos;
    }

    public IntExpr getPoscom() {
        return poscom;
    }

    public IntExpr getCodesize() {
        return codesize;
    }

    /*public IntExpr getCom() {
        return com;
    }*/

    public IntExpr getWmem() {
        return wmem;
    }

    public IntExpr getWpos() {
        return  wpos;
    }

    public IntExpr getVaresult() {
        return varesult;
    }

    public ArrayExpr getStack() {
        return stack;
    }

    public ArrayExpr getInitStack() {
        return initstack;
    }

    public IntExpr getVal0() { return val0; }

    public IntExpr getVal1() { return val1; }

    public IntExpr getVal(int i) {
        try {
            return (IntExpr) ctx.mkBound(GUARD + 3 * i + 1, intSort);
        } catch (Z3Exception e) {
            e.printStackTrace();
            throw new RuntimeException("getVal");
        }
    }

    public BoolExpr getValT(int i) {
        try {
            return (BoolExpr) ctx.mkBound(GUARD + 3 * i + 2, boolSort);
        } catch (Z3Exception e) {
            e.printStackTrace();
            throw new RuntimeException("getValT");
        }
    }
    public BoolExpr getValS(int i) {
        try {
            return (BoolExpr) ctx.mkBound(GUARD + 3 * i + 3, boolSort);
        } catch (Z3Exception e) {
            e.printStackTrace();
            throw new RuntimeException("getValS");
        }
    }
}
